const { ccclass, property } = cc._decorator;

@ccclass
export default class Helloworld extends cc.Component {

    // @property(cc.Label)
    // label: cc.Label = null;

    // @property
    // text: string = 'hello';

    TEXTURE_COUNT: number = 100;
    SPRITE_COUNT = 2000;
    W_COUNT = 40;
    H_COUNT = 50;
    W_WIDTH = 640;
    H_HEIGHT = 1136;
    callback: Function;

    sprites = [];

    start() {
        // 开启调试
        cc.dynamicAtlasManager.showDebug(true);
        cc.dynamicAtlasManager.maxFrameSize = 2048;
        // init logic
        // this.label.string = this.text;
        var self = this;
        //Create Textures
        let textures = [];
        for (let i = 0; i < self.TEXTURE_COUNT; ++i) {
            let spriteFrame = new cc.SpriteFrame(cc.url.raw("resources/Texture/" + i + ".png"));
            textures[i] = spriteFrame;
            cc.dynamicAtlasManager.insertSpriteFrame(spriteFrame);
            // console.log("Texture/" + i.toString());

            // cc.loader.loadRes("Texture/" + i.toString(), cc.SpriteFrame, function (err, spriteFrame) {
            // textures[i] = spriteFrame;
            // });
        }

        //Create Sprites
        for (let i = 0; i < self.SPRITE_COUNT; ++i) {
            let node = new cc.Node(i.toString())
            //调用新建的node的addComponent函数，会返回一个sprite的对象  
            let sprite = node.addComponent(cc.Sprite)

            sprite.sizeMode = cc.Sprite.SizeMode.CUSTOM;
            sprite.node.anchorX = 0.5;
            sprite.node.anchorY = 0.5;
            sprite.node.width = sprite.node.height = 64;
            // sprite.node.setScale(0.4);

            sprite.node.x = self.W_WIDTH / self.W_COUNT * (i % self.W_COUNT);
            sprite.node.y = self.H_HEIGHT / self.H_COUNT * (i / self.W_COUNT | 0);
            // console.log(sprite.node.x, sprite.node.y);

            //给sprite的spriteFrame属性 赋值  
            sprite.spriteFrame = textures[i % self.TEXTURE_COUNT];

            self.sprites.push(sprite);

            //把新的节点追加到self.node节点去。self.node，就是脚本挂载的节点  
            self.node.addChild(node)

        }
    }

    update() {
        var self = this;
        if (self.sprites.length != self.SPRITE_COUNT) {
            return;
        }
        for (let i = 0; i < self.SPRITE_COUNT; ++i) {
            self.sprites[i].node.angle += 3;
        }
    }
}

// //显示FPS
// let fpsCon = document.createElement('div');
// Object.assign(fpsCon.style, {
//     position: 'fixed',
//     background: '#000',
//     color: '#fff',
//     top: 0,
//     left: 0
// })
// document.body.appendChild(fpsCon);
// let arrFps = new Float64Array(10);
// let lastTime = Date.now();
// let pos = 0;
// function updateFps() {
//     let now = Date.now();
//     let delta = now - lastTime;
//     let fps = 1000 / delta;
//     arrFps[pos++] = fps;
//     if (pos >= arrFps.length) {
//         pos = 0;
//     }
//     fpsCon.innerHTML = 'FPS: ' + (arrFps.reduce((prev, next) => prev + next) / arrFps.length | 0);
//     lastTime = now;
//     requestAnimationFrame(updateFps);
// }
// requestAnimationFrame(updateFps);